//+------------------------------------------------------------------+
//|                                                         List.mqh |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
class CGenericArray_base
  {
public:
   T                 Data[];
   string            Name;
   //     CGenericArray_base(void){};
   //     CGenericArray_base(int size){ArrayResize(Data,size);}
                    ~CGenericArray_base(void){Clear();}
   int Count(){return ArraySize(Data);}
   void Clear(){ArrayFree(Data);}
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
class CGenericArray : public CGenericArray_base<T>
  {
public:
                     CGenericArray(void){};
                     CGenericArray(int size){ArrayResize(Data,size);}
   //    ~CGenericArray(void){Clear();}
   void Add(T item)
     {
      ArrayResize(Data,ArraySize(Data)+1,ArraySize(Data)+1);
      Data[ArraySize(Data)-1]=item;
     }
   void UniqueAdd(T item){if(!isElement(item))Add(item);}
   bool isElement(T item)
     {
      bool ans = false;
      for(int i=0;i<ArraySize(Data);i++)
        {
         if(Data[i]==item)
           {
            ans=true;
            break;
           }
        }
      return ans;
     }
   int FindIndex(T item)
     {
      int ans=-1;
      if(isElement(item))
        {
         for(int i=0;i<Count();i++)
            if(Data[i]==item)
              {
               ans=i;
               break;
              }
        }
      return ans;
     }
   void FindAll(T item,CGenericArray<int>&ind)
     {
      ind.Clear();
      for(int i=0;i<Count();i++)
        {
         if(Data[i]==item)
            ind.Add(i);
        }
     }
   void DeleteAll(T item)
     {
      CGenericArray<int>ind;
      FindAll(item,ind);
      if(ind.Count()>0)
        {
         for(int i=0;i<ind.Count();i++)
            DeleteByIndex(ind.Data[i]);
        }
     }
   void DeleteFirst(T item)
     {
      int ind=FindIndex(item);
      DeleteByIndex(ind);
     }
   void DeleteByIndex(int ind)
     {
      if(ind>=0)
        {
         T arr[];
         ArrayCopy(arr,Data,0,0,ind);
         ArrayCopy(arr,Data,ind,ind+1);
         Clear();
         AddRange(arr);
        }
     }
   void AddRange(T &collection[]){ArrayCopy(Data,collection,ArraySize(Data));}
   void ReplaceLast(T item){Data[ArraySize(Data)-1]=item;}
   T Max(){return Data[ArrayMaximum(Data)];};
   T Min(){return Data[ArrayMinimum(Data)];};
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
class CGenericArray_2: public CGenericArray_base<T>
  {
public:
                     CGenericArray_2(void){};
                     CGenericArray_2(int size){ArrayResize(Data,size);}
   //    ~CGenericArray_2(void){Clear();}
   void Add(T &item)
     {
      ArrayResize(Data,ArraySize(Data)+1,ArraySize(Data)+1);
      Data[ArraySize(Data)-1]=item;
     }
   void AddRange(T &collection[])
     {
      for(int i=0;i<ArraySize(collection);i++)
         Add(collection[i]);
     }
   void ReplaceLast(T &item){Data[ArraySize(Data)-1]=item;}
  };
//+------------------------------------------------------------------+
